UNIT UTauto;

interface

uses      mSuM,mUhr;

    const laenge = 60.0;
          breite = 30.0;
// Uses-Klausel ggf. anpassen

type
   Tauto = CLASS

     // Attribute
     PRIVATE
        meinStift : Stift;
        meineUhr : Uhr;
        x : zahl;
        y : zahl;
        zWinkel : zahl;

     // Methoden
     PRIVATE
        procedure zeichneDich; virtual; abstract;
     PUBLIC
        constructor init(px,py:zahl;pWinkel:Zahl);
        procedure bewegeDich;
        procedure dreheBis(pWinkel:zahl);
        procedure dreheUm(pWinkel:zahl);
        procedure setzeAuf(pXpos,pYPos:zahl);
        procedure warte;
        function hPosition; : ;
        function vPosition; : ;
        function winkel; : ;
        destructor GibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         Tauto: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichneDich -------------------------------------------------
procedure Tauto.zeichneDich; virtual; abstract;
  //Hier Code einfgen.

//-------- init --------------------------------------------------------
constructor Tauto.init(px,py:zahl;pWinkel:Zahl);
    begin
       meinStift := Stift.init;
       meineUhr := Uhr.init;
       x := px;
       y := py;
       zwinkel := pWinkel;
       zeichneDich;
    end;

//-------- bewegeDich --------------------------------------------------
procedure Tauto.bewegeDich;
  begin
    zeichneDich;
    x := x + 2.0 * cos(zwinkel*pi/180);
    y := y - 2.0 * sin(zwinkel*pi/180);
    zeichneDich;
    meineUhr.warte(1)
  end;

//-------- dreheBis ----------------------------------------------------
procedure Tauto.dreheBis(pWinkel:zahl);
  begin
    zeichneDich;
    zwinkel := pWinkel;
    zeichneDich;
    //meineUhr.warte(1)
  end;

//-------- dreheUm -----------------------------------------------------
procedure Tauto.dreheUm(pWinkel:zahl);
  begin
    zeichneDich;
    zwinkel := zwinkel + pWinkel;
    zeichneDich;
    //meineUhr.warte(1)
  end;

//-------- setzeAuf ----------------------------------------------------
procedure Tauto.setzeAuf(pXpos,pYPos:zahl);
   begin
      zeichneDich;
      x := pXpos ;
      y := pYpos ;
      zeichneDich
   end;

//-------- warte -------------------------------------------------------
procedure Tauto.warte;
   begin
      meineUhr.warte(1)
   end;

//-------- hPosition ---------------------------------------------------
function Tauto.hPosition; : ;
   begin
    result := x;
   end;

//-------- vPosition ---------------------------------------------------
function Tauto.vPosition; : ;
   begin
    result := y;
   end;

//-------- winkel ------------------------------------------------------
function Tauto.winkel; : ;
   begin
    result := zWinkel;
   end;

//-------- GibFrei -----------------------------------------------------
destructor Tauto.GibFrei;
    begin
      meinStift.gibfrei;
      meineUhr.gibfrei;
    end;  

end.
