program verwaltung;

uses
  mSuM,
  mAuto in 'mAuto.pas',
  mAmpel in 'mAmpel.pas';

var
  ampelzaehler:ganzeZahl;
  meinStift: Stift; 
  derBildschirm : Bildschirm; 
  dieTastatur : Tastatur; 
  dieMaus : Maus;
  Auto1:Auto;

begin

{----- Objekte erzeugen und initialisieren ----- }
  derBildschirm := Bildschirm.init;
  meinStift := Stift.init;
  dieTastatur := Tastatur.init;
  dieMaus := Maus.init;
  Auto1 := Auto.init(0,325,0);

  {----- Methodenaufrufe usw. -----}

  meinStift.bewegeBis(derBildschirm.breite-200,350);
  meinStift.schreibeText('Ende: hier Leertaste drcken');

  // obere Strassenlinie
  meinStift.bewegeBis(0,250);
  meinStift.runter ;
  meinStift.bewegeBis(derBildschirm.breite,250);
  meinStift.hoch;

  // untere Strassenlinie  (mit Einbuchtung)
  meinStift.bewegeBis(0,350);
  meinStift.runter ;
  meinStift.bewegeBis(200,350);
  meinStift.bewegeBis(300,300);
  meinStift.bewegeBis(derBildschirm.breite-300,300);
  meinStift.bewegeBis(derBildschirm.breite-200,350);
  meinStift.bewegeBis(derBildschirm.breite,350);
  meinStift.hoch;

repeat
     Auto1.bewegeDich ;

     //drehe dich in netsprechenden Bereichen zustzlich nach links
     if ( (Auto1.hPosition >= 165)  and
        (  Auto1.hPosition <= 220)   )
        or
        ( (Auto1.hPosition > derBildschirm.breite - 220)  and
          (Auto1.hPosition <= derBildschirm.breite - 166)  )
     then
        Auto1.dreheUm(1); //links

     //drehe dich in entsprechenden Bereichen zustzlich nach rechts
     if ( (Auto1.hPosition >= 255)  and
          (Auto1.hPosition <= 312)  )
        or
        ( (Auto1.hPosition > derBildschirm.breite - 318)  and
          (Auto1.hPosition <= derBildschirm.breite - 265)   )
     then
        Auto1.dreheUm(-1); //rechts

     // ggf wieder an den Anfang
     if Auto1.hPosition > derBildschirm.breite + 40 then
        begin
           Auto1.setzeAuf(0,325);
           Auto1.drehebis(0)
        end

until dieTastatur.wurdegedrueckt;


{----- Objekte auflsen -----}
  meinStift.gibFrei;
  dieMaus.gibFrei;
  dieTastatur.gibFrei;
  derBildschirm.gibFrei;
  Auto1.GibFrei;

end.
