UNIT mTAmpel;

interface

uses  mSuM,extctrls;
// Uses-Klausel ggf. anpassen

type
   TAmpel = CLASS

     // Attribute
     PRIVATE
        meinStift : BuntStift;
        aktuellefarbe : integer;
        dieTastatur : Tastatur;
        x : zahl;
        y : zahl;

     // Methoden
     PRIVATE
        procedure zeichneDich;
     PUBLIC
        constructor init(px,py:zahl);
        procedure schalteUm;
        function farbe : integer;
        function links : zahl;
        function oben : zahl;
        function rechts : zahl;
        function unten : zahl;
        destructor gibfrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAmpel: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichneDich -------------------------------------------------
procedure TAmpel.zeichneDich;
    begin
       with meinStift do begin
          bewegeBis(x,y);
          setzeFarbe(schwarz);
          setzeLinienbreite(1);
          runter;
          zeichneRechteck(16,32);

          hoch; // unteres Licht
          bewegeBis(x+8,y+24);
          runter;
          if aktuellefarbe = gruen then begin
              setzeFarbe(gruen);
              setzeLinienbreite(3)
          end
          else begin
              setzeFarbe(weiss);
              setzeLinienbreite(3);
              zeichneKreis(5);
              setzeFarbe(schwarz);
              setzeLinienbreite(1);
          end ;
          zeichneKreis(5);

          hoch; // oberes Licht
          bewegeBis(x+8,y+8);
          if aktuellefarbe = rot then begin
              setzeFarbe(rot);
              setzeLinienbreite(3)
          end
          else begin
              setzeFarbe(weiss);
              setzeLinienbreite(3);
              zeichneKreis(5);
              setzeFarbe(schwarz);
              setzeLinienbreite(1);
          end;
          zeichneKreis(5);

       end // with
  end;

//-------- init --------------------------------------------------------
constructor TAmpel.init(px,py:zahl);
    begin
       aktuelleFarbe := rot;
       meinStift := BuntStift.init;
       dieTastatur := Tastatur.init;
       x := px;
       y := py;
       zeichneDich
    end;

//-------- schalteUm ---------------------------------------------------
procedure TAmpel.schalteUm;
  begin
     if aktuellefarbe = rot then
        aktuellefarbe := gruen
     else
        aktuellefarbe := rot;
     zeichneDich
 end;

//-------- farbe -------------------------------------------------------
function TAmpel.farbe : integer;
   begin
      result := aktuellefarbe
   end;

//-------- links -------------------------------------------------------
function TAmpel.links : zahl;
   begin
      result := x
   end;

//-------- oben --------------------------------------------------------
function TAmpel.oben : zahl;
   begin
      result := y
   end;

//-------- rechts ------------------------------------------------------
function TAmpel.rechts : zahl;
   begin
      result := x+16
   end;

//-------- unten -------------------------------------------------------
function TAmpel.unten : zahl;
   begin
      result := y+32
   end;

//-------- gibfrei -----------------------------------------------------
destructor TAmpel.gibfrei;
    begin
      meinStift.gibfrei;
      //meineUhr.gibfrei;
      dieTastatur.gibFrei;
    end;  

end.
